// pages/workBench/components/tenement/components/bindMeter/index.js
// 0015980101
import { bindMeter, } from "../../../../../../service/tenement"
import { getWorkMeterDetail } from "../../../../../../service/meter"
import { alertInfo, alertSuccess } from "../../../../../../utils/index";
import request from "../../../../../../utils/request"
import dayjs from "../../../../../../utils/dayjs"
const { OK } = request
Component({

  /**
   * 组件的属性列表
   */
  properties: {
    tenement: String,
    tenementName: String,
    park: String,
    visible: Boolean,
    meterId: String,
  },

  /**
   * 组件的初始数据
   */
  data: {

  },

  /**
   * 组件的方法列表
   */
  methods: {
    onMeterFocus(e) {
      const { park } = this.data;
      if (!park) {
        alertInfo("请先选择园区")
        return;
      }
      this.setData({
        show: true,
        title: "电表",
        type: 'meter'
      })
    },
    onCancel() {
      this.setData({
        show: false,
        title: "",
        type: "",
      })
      // this.triggerEvent("close")
    },
    onClose() {
      this.setData({
        show: false,
        title: "",
        type: "",
      })
    },
    onChange(e) {
      const { name } = e.currentTarget.dataset;
      this.setData({
        [name]: e.detail
      })
    },
    async onSubmit() {
      const { overall, critical, peak, valley, park, tenement, meter } = this.data;
      const { code, message } = await bindMeter(park, tenement, { code: meter,  overall:overall? Number(overall) : overall, 
        critical : critical ? Number(critical) : critical, 
        peak: peak ? Number(peak) : peak, 
        valley : valley ? Number(valley) : valley, readAt: dayjs().format('YYYY-MM-DD HH:mm:ss') })
      if (code !== OK) {
        alertInfo(message)
        return;
      }
      alertSuccess("绑定成功")
      this.triggerEvent("ok")
    },
    onConfirm(e) {
      const { type, data } = e.detail;
      const that = this;
      console.log("e.deail", e.detail)
      switch(type) {
        case "meter":
          this.setData({
            meter: data.id,
            meterName: data.address,
            show: false,
          })
          this.getMeterDetail(data.id);
          break;
      }
    },
    async getMeterDetail(id) {
      const { code, message, data } = await getWorkMeterDetail(id)
      if (code !== OK) {
        alertInfo(message)
        return;
      }
      this.setData({
        overall: Number(data?.overall || 0),
        status: data?.breakType ? '合闸' : "分闸"
      })
    }
  }
})